IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'STATUS_LOTECTB_LANCTOESTOQ'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER STATUS_LOTECTB_LANCTOESTOQ
GO

CREATE TRIGGER STATUS_LOTECTB_LANCTOESTOQ ON LANCTOESTOQ
FOR DELETE
AS
DECLARE @V_CDLOTE            VARCHAR(20);
DECLARE @V_NRLANCLOTE        VARCHAR(06);
DECLARE @V_DTINICCTBL        DATETIME;
DECLARE @V_DTFINACCTBL       DATETIME;
DECLARE @V_CDEMPRESA         VARCHAR(02);
DECLARE @OLD_DTLANCESTQ      DATETIME;
DECLARE @OLD_CDFILIAL        VARCHAR(4);
DECLARE @OLD_NRLANCESTQ      VARCHAR(10);
DECLARE @V_IDTPGERACAOCONT   VARCHAR(01);
DECLARE @NEW_IDSTATUSCTBEST  VARCHAR(01);
DECLARE @V_INSERTED          INT;
DECLARE @V_DELETED           INT;
DECLARE @OLD_IDSTATUSCTBEST  VARCHAR(01);
BEGIN

   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT
     FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN
      DECLARE C_LANCTOESTOQ CURSOR FOR
         SELECT DTLANCESTQ, CDFILIAL,  NRLANCESTQ, IDSTATUSCTBEST
           FROM DELETED;
      OPEN C_LANCTOESTOQ;

      FETCH NEXT FROM C_LANCTOESTOQ INTO @OLD_DTLANCESTQ, @OLD_CDFILIAL, @OLD_NRLANCESTQ, @OLD_IDSTATUSCTBEST;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_CDEMPRESA = CDEMPRESA
              FROM FILIAL
             WHERE CDFILIAL = @OLD_CDFILIAL;

            SELECT @V_DTINICCTBL = DTINIINTCONTDFE, @V_DTFINACCTBL = DTFININTCONTDFE
              FROM CONTOPECTBL
             WHERE CDEMPRESA = @V_CDEMPRESA;

            SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

            SELECT @V_DELETED = COUNT(*) FROM DELETED;

            IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN

               IF ((@OLD_DTLANCESTQ >= @V_DTINICCTBL) AND (@OLD_DTLANCESTQ <= @V_DTFINACCTBL)) BEGIN
                  DECLARE C_RELALESTLANCLOT CURSOR FOR
                    SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                      FROM RELALESTLANCLOT
                     WHERE CDFILIAL   = @OLD_CDFILIAL
                       AND NRLANCESTQ = @OLD_NRLANCESTQ;

                      OPEN C_RELALESTLANCLOT;

                      FETCH NEXT FROM C_RELALESTLANCLOT INTO @V_CDLOTE, @V_NRLANCLOTE;

                        WHILE (@@FETCH_STATUS = 0) BEGIN

                           EXEC REVERTE_LOTE @V_CDEMPRESA, @V_CDLOTE;

                           DELETE FROM RELALESTLANCLOT
                            WHERE CDEMPRESA  = @V_CDEMPRESA
                              AND CDLOTE     = @V_CDLOTE
                              AND NRLANCLOTE = @V_NRLANCLOTE
                              AND CDFILIAL   = @OLD_CDFILIAL
                              AND NRLANCESTQ = @OLD_NRLANCESTQ;

                           DELETE FROM LANCLOTE
                            WHERE CDEMPRESA  = @V_CDEMPRESA
                              AND CDLOTE     = @V_CDLOTE
                              AND NRLANCLOTE = @V_NRLANCLOTE;

                           FETCH NEXT FROM C_RELALESTLANCLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
                        END;
                        CLOSE C_RELALESTLANCLOT;
                        DEALLOCATE C_RELALESTLANCLOT;
                     END
               ELSE BEGIN
                 RAISERROR('Excluso no pertida, lanamento fora do perodo de integrao DFE.', 16, 1);
               END;
            END;

         FETCH NEXT FROM C_LANCTOESTOQ INTO @OLD_DTLANCESTQ, @OLD_CDFILIAL, @OLD_NRLANCESTQ, @OLD_IDSTATUSCTBEST;
         END;
      CLOSE C_LANCTOESTOQ;
      DEALLOCATE C_LANCTOESTOQ;
   END;
END;
GO